import { Entity, ManyToOne, PrimaryKey, Property } from '@mikro-orm/core'
import { BaseEntity } from '#application/bases/baseEntity'
import { Character } from './character'
import { Zone } from './zone'

@Entity()
export class Chat extends BaseEntity {
  @PrimaryKey()
  id!: number

  @ManyToOne(() => Character)
  character!: Character

  @ManyToOne(() => Zone)
  zone!: Zone

  @Property()
  message!: string

  @Property()
  createdAt = new Date()

  setId(id: number) {
    this.id = id
    return this
  }

  getId() {
    return this.id
  }

  setCharacter(character: Character) {
    this.character = character
    return this
  }

  getCharacter() {
    return this.character
  }

  setZone(zone: Zone) {
    this.zone = zone
    return this
  }

  getZone() {
    return this.zone
  }

  setMessage(message: string) {
    this.message = message
    return this
  }

  getMessage() {
    return this.message
  }

  setCreatedAt(createdAt: Date) {
    this.createdAt = createdAt
    return this
  }

  getCreatedAt() {
    return this.createdAt
  }
}
